//+------------------------------------------------------------------+
//|                                               Heiken_Ashi_EA.mq4 |
//|                                                       WSAStartup |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "WSAStartup"
#property link      ""

extern string s1="TIME TO WAIT IN SECONDS";
extern int TimeSpan=300;
extern int TimeSpanClose=300;
extern string s2="-----------------------";
extern int TakeProfit=1500;
extern int StopLoss=1500;
extern int Magic=12367;

extern    string    _____________011____________    =    "HA1";  
extern int MaMetod=2;
extern int MaPeriod=30;
extern int MaMetod2 =3;
extern int MaPeriod2=2;
extern int TimeSpanHa1=300;
extern int TimeSpanCloseHa1=300;

extern    string    _____________012____________    =    "HA2";   
extern    int    MaMetod3    =    2;   
extern    int    MaPeriod3    =    6;   
extern    int    MaMetod4    =    3;   
extern    int    MaPeriod4    =    2;
extern    int    TimeSpanHa2=300;
extern    int    TimeSpanCloseHa2=300;

extern    string    _____________014____________    =    "Par";   
extern    double    Step    =    0.02;   
extern    double    Maximum    =    0.2;
extern    int       TimeSpanParabolic=300;
extern    int       TimeSpanCloseParabolic=300;

extern    string    _____________013____________    =    "Bband";   
extern int    Length=20;      // Bollinger Bands Period
extern int    Deviation=2;    // Deviation was 2
extern double MoneyRisk=1.00; // Offset Factor
extern int    Signal=1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
extern int    Line=1;         // Display line mode: 0-no,1-yes  
extern int    Nbars=1000;
extern int TimeSpanBBand=300;
extern int TimeSpanCloseBBand=300;
//---- indicator buffers

extern bool SoundON=true;

extern    bool     use_HA1 = false;
extern    bool     use_HA2 = false;   
extern    bool     use_Parabolic = false;
extern    bool     use_BBand = false;

	string ha1Status = "default";
	string ha2Status = "default";
	string parStatus = "default";
	string bbandStatus = "default";
	string commonStatus = "default";


int nTicket;
int flag;

//HA1
double haOpen;
double haClose;
double haOpen2;
double haClose2;

//Parabolic
double parabolic;

//HA2
double haOpen3;
double haClose3;
double haOpen4;
double haClose4;

//BBand
double UpTrendBuffer;
double DownTrendBuffer;

datetime TimeNow;

datetime TimeNowHA1;
datetime TimeNowHA2;
datetime TimeNowParabolic;
datetime TimeNowBBand;

datetime CandleTimeHA1;
datetime CandleTimeHA2;
datetime CandleTimeParabolic;
datetime CandleTimeBBand;

//Comment("main start()");

datetime CandleTime = 0;
int nTrend = 0;
int type = 1;

	int HA1Control(){
		int ha1 = -1;
		if(OrdersTotal()!=0)
		{	
			OrderSelect(nTicket,SELECT_BY_TICKET);
			if(OrderMagicNumber()==Magic)
			{      
				if((OrderType()==OP_SELL) && (nTrend==1))
				{
					TimeNowHA1=TimeCurrent(); 
					if((TimeNowHA1-CandleTimeHA1)>TimeSpanCloseHa1) 
					{
					//OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
					  //Comment("HA close");
					ha1 = 5;
					}
				}

				if((OrderType()==OP_BUY) && (nTrend==2))
				{
					TimeNowHA1=TimeCurrent();
					if((TimeNowHA1-CandleTimeHA1)>TimeSpanCloseHa1) 
					{
					//OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
					  ///Comment("HA close");
					    ha1 = 5;  
				    }
				}
			}
		}

		//-------------------------HA1--------------------------------//
		haOpen=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,2,0);
		haClose=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,3,0);

		haOpen2=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,1,0);
		haClose2=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,0,0);
		//---------------------------------------------------------------------//


		if ((haOpen>=haClose)&&(haOpen2<haClose2)) 
		{
			if(nTrend==2)
			{

				TimeNowHA1=TimeCurrent();
				if((TimeNowHA1-CandleTimeHA1)>TimeSpanHa1)
				{
					if((OrdersTotal()==0) && (OrderType()==0))
				  {
					//nTicket=OrderSend(Symbol(),OP_SELL,1,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"sell order",Magic,0,Red);
					ha1 = OP_SELL;
					 
					 ha1Status = "HA1 Status: SELL";
				  }
				}

			}
			else
			{
				CandleTimeHA1=TimeCurrent();
				nTrend=2;

			}

		}
		else if((haOpen < haClose)&&(haOpen2 >= haClose2))
		{

			if(nTrend==1)
			{
				TimeNowHA1=TimeCurrent();
				if((TimeNowHA1-CandleTimeHA1)>TimeSpanHa1)
				{
					if((OrdersTotal()==0)&& (OrderType()==1))
					{
						//nTicket=OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"buy order",Magic,0,Green);
						ha1 = OP_BUY;
						 
						
						 ha1Status = "HA1 Status: BUY";
					}
				}
				
			}
			
			else
			{
				CandleTimeHA1=TimeCurrent();
				nTrend=1;

			}

			
		}
		return (ha1);
	}

int HA2Control(){
	int ha2 = -1;
	if(OrdersTotal()!=0)
  {
    OrderSelect(nTicket,SELECT_BY_TICKET);
    if(OrderMagicNumber()==Magic)
    {      
      if((OrderType()==OP_SELL) && (nTrend==1))
      {
        TimeNowHA2=TimeCurrent(); 
        if((TimeNowHA2-CandleTimeHA2)>TimeSpanCloseHa2) 
        {
        //OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
         ha2 = 5;
        }
      }
      
      if((OrderType()==OP_BUY) && (nTrend==2))
      {
        TimeNowHA2=TimeCurrent();
        if((TimeNowHA2-CandleTimeHA2)>TimeSpanCloseHa2) 
        //OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
        ha2 = 5;  
      }
    }
  }

	//-------------------------HA2--------------------------------//
	haOpen3=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod3,MaPeriod3,MaMetod4,MaPeriod4,2,0);
	haClose3=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod3,MaPeriod3,MaMetod4,MaPeriod4,3,0);

	haOpen4=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod3,MaPeriod3,MaMetod4,MaPeriod4,1,0);
	haClose4=iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMetod3,MaPeriod3,MaMetod4,MaPeriod4,0,0);
	//---------------------------------------------------------------------//


	if ((haOpen3>=haClose3)&&(haOpen4<haClose4)) 	
	  {
		if(nTrend==2)
		{
		 
		  TimeNowHA2=TimeCurrent();
		  if((TimeNowHA2-CandleTimeHA2)>TimeSpanHa2)
		  {
			  if((OrdersTotal()==0) && (OrderType()==0))
			  {				  
			  //nTicket=OrderSend(Symbol(),OP_SELL,1,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"sell order",Magic,0,Red);
			   ha2 = OP_SELL;
			   ha2Status = "HA2 Status: SELL";
		    }
		  }
		 

		}
		else
		 {
		   CandleTimeHA2=TimeCurrent();
		   nTrend=2;
		 
		 }	
		
		
	  }
	  else
	  {
		
		if(nTrend==1)
		{
			TimeNowHA2=TimeCurrent();
			if((TimeNowHA2-CandleTimeHA2)>TimeSpanHa2)
			{
				if((OrdersTotal()==0)&& (OrderType()==1))
				{
					//nTicket=OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"buy order",Magic,0,Green);
					ha2 = OP_BUY;
					 ha2Status = "HA2 Status: BUY";
				}
			}
	
		
		}
		
		else
		{
		  CandleTimeHA2=TimeCurrent();
		  nTrend=1;
		 
		}
	  }
		return (ha2);
}



int parabolicControl(){
int par = -1;
	if(OrdersTotal()!=0)
  {
    OrderSelect(nTicket,SELECT_BY_TICKET);
    if(OrderMagicNumber()==Magic)
    {      
      if((OrderType()==OP_SELL) && (nTrend==1))
      {
        TimeNowParabolic=TimeCurrent(); 
        if((TimeNowParabolic-CandleTimeParabolic)>TimeSpanCloseParabolic) 
        //OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
        par = 5;
      }
      
      if((OrderType()==OP_BUY) && (nTrend==2))
      {
        TimeNowParabolic=TimeCurrent();
        if((TimeNowParabolic-CandleTimeParabolic)>TimeSpanCloseParabolic) 
        //OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
         par = 5;  
      }
    }
  }

	//-------------------------Parabolic--------------------------------//
	parabolic = iSAR(NULL,0,Step,Maximum,0);
	//---------------------------------------------------------------------//
	


	if (parabolic > Close[0]) 
	  {
		if(nTrend==2)
		{
		 
		  TimeNowParabolic=TimeCurrent();
		  if((TimeNowParabolic-CandleTimeParabolic)>TimeSpanParabolic)
		  {
			  if((OrdersTotal()==0) && (OrderType()==0))
				{			  
			      //nTicket=OrderSend(Symbol(),OP_SELL,1,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"sell order",Magic,0,Red);
			      par = OP_SELL;
			      
			      parStatus = "Par Status: SELL";
			    }
		  }
		  
		}
		else
		{
		  CandleTimeParabolic=TimeCurrent();
		  nTrend=2;
		 
		}
		
	  }
	  else if(parabolic < Close[0]) 
	  {
		
		if(nTrend==1)
		{
			TimeNowParabolic=TimeCurrent();
			if((TimeNowParabolic-CandleTimeParabolic)>TimeSpanParabolic)
			{
				if((OrdersTotal()==0)&& (OrderType()==1))
				{
					//nTicket=OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"buy order",Magic,0,Green);
					par = OP_BUY;
					 
               parStatus = "Par Status: BUY";
				}
			}
		}
		    else
		    {
		      CandleTimeParabolic=TimeCurrent();
		      nTrend=1;
		 
		    }
	  }
	 
		return (par);
}

int bBandControl(){
   	int bband = -1;
   


	if(OrdersTotal()!=0)
  {
    OrderSelect(nTicket,SELECT_BY_TICKET);
    if(OrderMagicNumber()==Magic)
    {      
      if((OrderType()==OP_SELL) && (nTrend==1))
      {
        TimeNowBBand=TimeCurrent(); 
        if((TimeNowBBand-CandleTimeBBand)>TimeSpanCloseBBand) 
        {
        //OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
          bband = 5;
        }      
      }
      
      if((OrderType()==OP_BUY) && (nTrend==2))
      {
        TimeNowBBand=TimeCurrent();
        if((TimeNowBBand-CandleTimeBBand)>TimeSpanCloseBBand) 
        {
        //OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
            bband = 5;  
        }
      }
    }
  }


	//-------------------------BBands_Stop--------------------------------//
	UpTrendBuffer = iCustom(NULL,0,"BBands_Stop_v1",Length,Deviation,0,0);
	DownTrendBuffer = iCustom(NULL,0,"BBands_Stop_v1",Length,Deviation,1,0);
	//---------------------------------------------------------------------//
	

	if (DownTrendBuffer  > Close[0]) 
	  {
		if(nTrend==2)
		{
		 
		  TimeNowBBand=TimeCurrent();
		  if((TimeNowBBand-CandleTimeBBand)>TimeSpanBBand)
		  {
			  if((OrdersTotal()==0) && (OrderType()==0))
			   {			  
			   //nTicket=OrderSend(Symbol(),OP_SELL,1,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"sell order",Magic,0,Red);
			   bband = OP_SELL;
			   bbandStatus = "Bband Status: SELL";
			  }
		  }
		  
 
		}
      else
		{
		  CandleTimeBBand=TimeCurrent();
		  nTrend=2;
		}
		
	  }
	  else if(UpTrendBuffer < Close[0]) 
	  {
		
		if(nTrend==1)
		{
			TimeNowBBand=TimeCurrent();
			if((TimeNowBBand-CandleTimeBBand)>TimeSpanBBand)
			{
				if((OrdersTotal()==0)&& (OrderType()==1))
				{
					//nTicket=OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"buy order",Magic,0,Green);
					   bband = OP_BUY;
					   bbandStatus = "Bband Status: BUY";
				}
			}

		
		}
		else
		{
		  CandleTimeBBand=TimeCurrent();
		  nTrend=1;
		 
		}
	  }
		return (bband);
}

//+------------------------------------------------------------------+
//| Last Decision Point                                 			 |
//+------------------------------------------------------------------+
void controlOrderType()
{

    bool buyDecision = true;
    bool sellDecision = true;
    bool closeDesicion = true;
 	int par = -1;
	int bband = -1;
	int ha1 = -1;
	int ha2 = -1;
	

	
	
	
		//Comment("cntrlOrderType");

	
/*if(use_HA1 == true){
   ha1 = HA1Control(); 
   if(ha1 == OP_BUY){
      ha1Status = "HA1 Status: BUY";
   }
   else if(ha1 == OP_SELL){
      ha1Status = "HA1 Status: SELL";
   }
}

if(use_HA2 == true){
	ha2 = HA2Control(); 
   if(ha2 == OP_BUY){
      ha2Status = "HA2 Status: BUY";   
   }
   else if(ha2 == OP_SELL){
      ha2Status = "HA2 Status: BUY";   
   }
}
if(use_Parabolic == true){	
   par = parabolicControl();
   if(par == OP_BUY){
      parStatus = "PAR Status: BUY";   
   }
   else if(par == OP_SELL){
      parStatus = "PAR Status: SELL";   
   }   
}
   
   
if(use_BBand == true){
   bband = bBandControl();
   if(bband == OP_BUY){
      bbandStatus = "BBAND Status: BUY";   
   }
   else if(bband == OP_SELL){
      bbandStatus = "BBAND Status: SELL";
   }
}
*/
 // ha1 = HA1Control(); 

   /*if(ha1 == OP_BUY){
   
   Comment("HA1: buy");
   }
   else if (ha1 == OP_SELL){
   
   Comment("HA1: sell");
   }
   else{
   
   Comment("CLOse: ",OP_SELL);
   
   }*/
   

 
   
   if(use_HA1 == true){
	    ha1 = HA1Control(); 
        buyDecision  =  (buyDecision && (ha1 == OP_BUY));
        sellDecision =  (sellDecision && (ha1 == OP_SELL));
        closeDesicion = (closeDesicion && (ha1 == 5));		
	}
	
	if(use_HA2 == true){
		ha2 = HA2Control(); 
		buyDecision  =  (buyDecision && (ha2 == OP_BUY));
		sellDecision =  (sellDecision && (ha2 == OP_SELL));
		closeDesicion = (closeDesicion && (ha2 == 5));		
	
	}
	if(use_Parabolic == true){
		par = parabolicControl(); 
		buyDecision  =  (buyDecision && (par == OP_BUY));
		sellDecision =  (sellDecision && (par == OP_SELL));
		closeDesicion = (closeDesicion && (par == 5));
	}
	if(use_BBand == true){
		bband = bBandControl(); 
		buyDecision  =  (buyDecision && (bband == OP_BUY));
		sellDecision =  (sellDecision && (bband == OP_SELL));
		closeDesicion = (closeDesicion && (bband == 5));
	}
   //Comment("1)",ha1Status,"\n","2)",ha2Status,"\n","3)",parStatus,"\n","4)",bbandStatus,"\n","\n","5",commonStatus);
	if(buyDecision == true)
	{
         nTicket = OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"buy order",Magic,0,Green);
	      flag = 1;
	      commonStatus = "BUY COMMON";
	}	 
   else if(sellDecision == true)
   {
         nTicket = OrderSend(Symbol(),OP_SELL,1,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"sell order",Magic,0,Red);
         flag = 2;
         commonStatus = "SELL COMMON";
   }
   else if(closeDesicion == true)
   {
		nTicket = OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
		nTicket = OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
		flag = 0;
		commonStatus = "CLOSE COMMON";
   }
	//Comment("1)",ha1Status,"\n","2)",ha2Status,"\n","3)",parStatus,"\n","4)",bbandStatus,"\n","\n","5) ",commonStatus);
}

int init()
{
  return(0);
}

int deinit()
{
  return(0);
}


int start()
{
/*
	//-------------------------Latency--------------------------------------//
	datetime tm, latest = 0;
	int i = HistoryTotal();
	while (i > 0)
	{
		i--;
		OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
		tm = OrderCloseTime();
			if (latest < tm)
			{
				latest = tm;
				type = OrderType();
	 
			}	
	}
	//---------------------------------------------------------------------//
	*/

	controlOrderType();

  return(0);
 }